//  Copyright 2016 root.ext@gmail.com
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

import 'dart:typed_data';
import 'vulkan.dart';

void main(){
  Vulkan vk = new Vulkan();
  var instance = new Uint8List(8);

  var ai = new VkApplicationInfo();
  ai.sType  = VK_STRUCTURE_TYPE_APPLICATION_INFO;
  ai.pApplicationName = "Test\0";
  ai.applicationVersion = 1;
  ai.pEngineName = "Engine\0";
  ai.apiVersion = (((1) << 22) | ((0) << 12) | (0));

  var ici = new VkInstanceCreateInfo();
  ici.sType = 1;
  ici.pApplicationInfo = ai;

  var result = vk.vkCreateInstance(ici, 0, instance);
  assert(result == VK_SUCCESS);
  print('instance is ok');

  var count = new Uint8List(4);
  result = vk.vkEnumeratePhysicalDevices(new ByteData.view(instance.buffer).getInt64(0, Endianness.HOST_ENDIAN), count, 0);
  assert(result == VK_SUCCESS);
  print('physical devices count ${new ByteData.view(count.buffer).getUint32(0, Endianness.HOST_ENDIAN)}');
}